<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.4.7
 * @author		hikashop.com
 * @copyright	(C) 2010 HIKARI SOFTWARE. All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgHikashoppaymentBluepaid extends JPlugin
{
	var $accepted_currencies = array(
		"AUD" => "036", //Dollar australien
		"CAD" => "124", //Dollar canadien
		"CNY" => "156", //Renminbi yuan chinois
		"DKK" => "208", //Couronne danoise
		"JPY" => "392", //Yen
		"SEK" => "752", //Couronne suédoise
		"CHF" => "756", //Franc suisse
		"GBP" => "826", //Livre sterling
		"USD" => "840", //Dollar des États-Unis
        	"EUR" => "978"  //Euro   
	);

    var $debugData = array();

    function onPaymentDisplay(&$order,&$methods,&$usable_methods){
    	if(!empty($methods)){
    		foreach($methods as $method){
				if($method->payment_type!='ceca' || !$method->enabled){
					continue;
				}
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop::get('class.zone');
	    			$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				$currencyClass = hikashop::get('class.currency');
				$null=null;
				$currency_id = intval(@$order->total->prices[0]->price_currency_id);
				$currency = $currencyClass->getCurrencies($currency_id,$null);
				if(!empty($currency) && !in_array(@$currency[$currency_id]->currency_code,$this->accepted_currencies)){
					return true;
				}
				$usable_methods[$method->ordering]=$method;
    		}
    	}
    	return true;
    }
    function onPaymentSave(&$cart,&$rates,&$payment_id){
    	$usable = array();
    	$this->onPaymentDisplay($cart,$rates,$usable); 
    	$payment_id = (int) $payment_id;
    	foreach($usable as $usable_method){
    		if($usable_method->payment_id==$payment_id){
    			return $usable_method;
    		}
    	}
    	return false;
    }
    function onAfterOrderConfirm(&$order,&$methods,$method_id){
    	$method =& $methods[$method_id];
	$tax_total = '';
	$discount_total = '';
	$currencyClass = hikashop::get('class.currency');
	$currencies=null;
	$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
	$currency=$currencies[$order->order_currency_id];

	$user = hikashop::loadUser(true);

	$vars = Array(		
		"MerchantID" => $method->payment_params->merchantId,
		"AcquirerBIN" => $method->payment_params->acquirerBin,
		"TerminalID" => $method->payment_params->terminalId,		
		"Num_operacion" => $order->order_id,
		"TipoMoneda" => @$this->accepted_currencies[$currency->currency_code,
		"Exponente" => "2",
		"Cifrado" => "SHA1",
		"Idioma" => "1",
		"Pago_soportado" => "SSL",
		"Pago_elegido" => "",
		"Descripcion" => "",
		"PAN" => "",
		"Caducidad" => "",
		"CVV2" => "",
		"Referencia" => ""
	);
	$vars['Importe'] => str_replace(array('.',','),'',round($order->cart->full_total->prices[0]->price_value_with_tax,(int)$currency->currency_locale['int_frac_digits'])*100);		

	if(empty($method->payment_params->return_url)){
		$return_url = hikashop::completeLink('checkout&task=after_end&order_id='.$order->order_id);
	}else{
		$return_url = $method->payment_params->return_url;
	}
	$vars['URL_OK']=$return_url;

	$cancel_url =hikashop::completeLink('order&task=cancel_order&order_id='.$order->order_id);
	$vars['URL_NOK']=$cancel_url;

	$vars["firma"]=sha1(
		$method->payment_params->encriptionKey .
		$vars['MerchantID'] .
		$vars['AcquirerBIN'] .
		$vars['TerminalID'] .
		$vars['Num_operacion'] .
		$vars['Importe'] .
		$vars['TipoMoneda'] .
		$vars['Exponente'] .
		$vars['Cifrado'] .
		$vars['URL_OK'] .
		$vars['URL_NOK']
	);

	JHTML::_('behavior.mootools');
	$app =& JFactory::getApplication();
	$name = $method->payment_type.'_end.php';
    	$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
    	if(!file_exists($path)){
    		if(version_compare(JVERSION,'1.6','<')){
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
    		}else{
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
    		}
    		if(!file_exists($path)){
    			return true;
    		}
    	}
    	require($path);
    	return true;
    }
    function onPaymentNotification(&$statuses){
    	$pluginsClass = hikashop::get('class.plugins');
	$elements = $pluginsClass->getMethods('payment','ceca');
	if(empty($elements)) return false;
	$element = reset($elements);
	if(!$element->payment_params->notification){
		return false;
	}
    	$vars = array();
    	$data = array();
    	$filter = & JFilterInput::getInstance();
    	foreach($_POST as $key => $value){
    		$key = $filter->clean($key);
    		$value = JRequest::getString($key);
    		$vars[$key]=$value;
    	}

	$vars['firma_calculada'] = sha1(
		$element->payment_params->encriptionKey .
		@$vars['MerchantID'] .
		@$vars['AcquirerBIN'] .
		@$vars['TerminalID'] .
		@$vars['Num_operacion'] .
		@$vars['Importe'] .
		@$vars['TipoMoneda'] .
		@$vars['Exponente'] .
		@$vars['Referencia']
	);

	if($element->payment_params->debug){
		echo print_r($vars,true)."\n\n\n";
	}    	

	$orderClass = hikashop::get('class.order');
	$dbOrder = $orderClass->get((int)@$vars['Num_operacion']);
	$order = null;
	$order->order_id = @$dbOrder->order_id;
	if(!empty($dbOrder)){
		$order->old_status->order_status=$dbOrder->order_status;
		$url = HIKASHOP_LIVE.'administrator/index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$order->order_id;
		$order_text = "\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE',hikashop::encode($dbOrder),HIKASHOP_LIVE);
		$order_text .= "\r\n".str_replace('<br/>',"\r\n",JText::sprintf('ACCESS_ORDER_WITH_LINK',$url));
	}else{
		echo "Could not load any order for your notification ".@$vars['Num_operacion'];
		return false;
	}
	if($element->payment_params->debug){
		echo print_r($dbOrder,true)."\n\n\n";
	}    
	$mailer =& JFactory::getMailer();
	$config =& hikashop::config();
	$sender = array( 
		$config->get('from_email'),
		$config->get('from_name') );
	$mailer->setSender($sender);
	$mailer->addRecipient(explode(',',$config->get('payment_notification_email')));
	
	if(!empty($element->payment_params->ips)){
		$ip = hikashop::getIP();
		$ips = str_replace(array('.','*',','),array('\.','[0-9]+','|'),$element->payment_params->ips);
		if(!preg_match('#('.implode('|',$ips).')#',$ip)){
			$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','CECA').' '.JText::sprintf('IP_NOT_VALID',hikashop::encode($dbOrder)));
			$body = str_replace('<br/>',"\r\n",JText::sprintf('NOTIFICATION_REFUSED_FROM_IP','CECA',$ip,implode("\r\n",$element->payment_params->ips)))."\r\n\r\n".$order_text;
			$mailer->setBody($body);
			$mailer->Send();
		JError::raiseError( 403, JText::_( 'Access Forbidden' ));
		return false;
		}
    	}
	
	if ($vars['firma_calculada']!=@$vars['firma']) {
		$mailer->setSubject(JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER','CECA').'invalid response');
		$body = JText::sprintf("Hello,\r\n A CECA notification was refused because the response from the CECA server was invalid")."\r\n\r\n".$order_text;
		$mailer->setBody($body);
		$mailer->Send();
		if($element->payment_params->test){
			echo 'invalid response'."\n\n\n";
		} 
		return false;
	}
/*
	    $vars['status']=strtolower(@$vars['etat']);
		if(!in_array($vars['status'],array("attente","ok"))) {
			if($vars['status']=="annu"){
				$vars['payment_status']='Cancelled';
			}elseif($vars['status']=="ko"){
				$vars['payment_status']='Failed';
			}else{
				$vars['payment_status']='Unknown';
			}
			$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','Bluepaid',$vars['payment_status'])).' '.JText::_('STATUS_NOT_CHANGED')."\r\n\r\n".$order_text;
		 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION','Bluepaid',$vars['payment_status']));
			$mailer->setBody($body);
			$mailer->Send();
			if($element->payment_params->debug){
				echo 'payment with code '.@$vars['status'].(!empty($vars['failed_reason_code'])?' : '.@$vars['failed_reason_code']:'')."\n\n\n";
			} 
			return false;
		 }
*/
	$order->history->history_reason=JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
	$order->history->history_notified=0;
	$order->history->history_amount=@$vars['Importe'].@$vars['TipoMoneda'];
	$order->history->history_payment_id = $element->payment_id;
	$order->history->history_payment_method =$element->payment_type;
	$order->history->history_data = ob_get_clean();
	$order->history->history_type = 'payment';
	$order->order_status = $element->payment_params->verified_status;
	$vars['payment_status']='Accepted';
	$order->history->history_notified=1;

	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION','CECA',$vars['payment_status']));
	$body = str_replace('<br/>',"\r\n",JText::sprintf('PAYMENT_NOTIFICATION_STATUS','CECA',$vars['payment_status'])).' '.JText::sprintf('ORDER_STATUS_CHANGED',$statuses[$order->order_status])."\r\n\r\n".$order_text;
	$mailer->setBody($body);
	$mailer->Send();
	$orderClass->save($order);
	
	return true;
}
    function onPaymentConfiguration(&$element){
    	$subtask = JRequest::getCmd('subtask','');  
    	if($subtask=='ips'){
    		$ips = null;
			echo implode(',',$this->_getIPList($ips));
			exit;
    	}else{ 
	    	$this->ceca = JRequest::getCmd('name','ceca');  
			if(empty($element)){
				$element = null;
	    		$element->payment_name='CECA';
	    		$element->payment_description='Pasarela de pago de las Cajas de Ahorro CECA';
	    		$element->payment_images='MasterCard,VISA,Credit_card,American_Express';
	    		$element->payment_type=$this->ceca;
	    		$element->payment_params=null;
	    		$list=null;
	    		$element->payment_params->notification=true;
	    		$element->payment_params->ips=$this->_getIPList($list);
	    		$element->payment_params->url='http://tpv.ceca.es:8000/cgi-bin/tpv/';
			$element->payment_params->invalid_status='cancelled';
	    		$element->payment_params->pending_status='created';
	    		$element->payment_params->verified_status='confirmed';
	    		$element = array($element);
	    	}
	    	$lang = &JFactory::getLanguage();
			$locale=strtoupper(substr($lang->get('tag'),0,2));
			$key = key($element);
			$element[$key]->payment_params->status_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=ceca&tmpl=component&lang='.strtolower($locale);
	    	$bar = & JToolBar::getInstance('toolbar');
			JToolBarHelper::save();
			JToolBarHelper::apply();
			JToolBarHelper::cancel();
			JToolBarHelper::divider();
			$bar->appendButton( 'Pophelp','payment-bluepaid-form');
			hikashop::setTitle('Bluepaid','plugin','plugins&plugin_type=payment&task=edit&name='.$this->bluepaid);
			$app =& JFactory::getApplication();
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->bluepaid);
			$this->address = hikashop::get('type.address');
			$this->category = hikashop::get('type.categorysub');
			$this->category->type = 'status';
    	}
    }
    function onPaymentConfigurationSave(&$element){
  		if(!empty($element->payment_params->ips)){
    		$element->payment_params->ips=explode(',',$element->payment_params->ips);
    	}
		return true;
    }
    function _getIPList(&$ipList){
    	$ipList = array_merge(gethostbynamel('tpv.ceca.es'),gethostbynamel('tpv.ceca.es'));
    	if(!empty($ipList)){
    		$newList = array('193.33.47.34','193.33.47.35');
	    	foreach($ipList as $k => $ip){
	    		$ipParts = explode('.',$ip);
	    		if(!in_array($ip,$newList)){
	    			$newList[]=$ip;
	    		}
	    	}
	    	$ipList = $newList;
    	}
    	return $ipList;
    }
}
